pcl::CovarianceSampling< PointT, PointNT > Class Template Reference

Point Cloud sampling based on the 6D covariances. More...

`#include <pcl/filters/covariance_sampling.h>`

Inheritance diagram for pcl::CovarianceSampling< PointT, PointNT >:

## Public Types

using | Ptr = shared_ptr< CovarianceSampling< PointT, PointNT > >
using | ConstPtr = shared_ptr< const CovarianceSampling< PointT, PointNT > >
Public Types inherited from pcl::FilterIndices< PointT >
using | PointCloud = pcl::PointCloud< PointT >
using | Ptr = shared_ptr< FilterIndices< PointT > >
using | ConstPtr = shared_ptr< const FilterIndices< PointT > >
Public Types inherited from pcl::Filter< PointT >
using | Ptr = shared_ptr< Filter< PointT > >
using | ConstPtr = shared_ptr< const Filter< PointT > >
using | PointCloud = pcl::PointCloud< PointT >
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
Public Types inherited from pcl::PCLBase< PointT >
using | PointCloud = pcl::PointCloud< PointT >
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
using | PointIndicesPtr = PointIndices::Ptr
using | PointIndicesConstPtr = PointIndices::ConstPtr

## Public Member Functions

| CovarianceSampling ()
| Empty constructor. More...
void | setNumberOfSamples (unsigned int samples)
| Set number of indices to be sampled. More...
unsigned int | getNumberOfSamples () const
| Get the value of the internal num_samples_ parameter. More...
void | setNormals (const NormalsConstPtr &normals)
| Set the normals computed on the input point cloud. More...
NormalsConstPtr | getNormals () const
| Get the normals computed on the input point cloud. More...
double | computeConditionNumber ()
| Compute the condition number of the input point cloud. More...
bool | computeCovarianceMatrix (Eigen::Matrix< double, 6, 6 > &covariance_matrix)
| Computes the covariance matrix of the input cloud. More...
Public Member Functions inherited from pcl::FilterIndices< PointT >
| FilterIndices (bool extract_removed_indices=false)
| Constructor. More...
void | filter (Indices &indices)
| Calls the filtering method and returns the filtered point cloud indices. More...
void | setNegative (bool negative)
| Set whether the regular conditions for points filtering should apply, or the inverted conditions. More...
bool | getNegative () const
| Get whether the regular conditions for points filtering should apply, or the inverted conditions. More...
void | setKeepOrganized (bool keep_organized)
| Set whether the filtered points should be kept and set to the value given through setUserFilterValue (default: NaN), or removed from the PointCloud, thus potentially breaking its organized structure. More...
bool | getKeepOrganized () const
| Get whether the filtered points should be kept and set to the value given through setUserFilterValue (default = NaN), or removed from the PointCloud, thus potentially breaking its organized structure. More...
void | setUserFilterValue (float value)
| Provide a value that the filtered points should be set to instead of removing them. More...
Public Member Functions inherited from pcl::Filter< PointT >
| Filter (bool extract_removed_indices=false)
| Empty constructor. More...
IndicesConstPtr const | getRemovedIndices () const
| Get the point indices being removed. More...
void | getRemovedIndices (PointIndices &pi)
| Get the point indices being removed. More...
void | filter (PointCloud &output)
| Calls the filtering method and returns the filtered dataset in output. More...
Public Member Functions inherited from pcl::PCLBase< PointT >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()=default
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (std::size_t row_start, std::size_t col_start, std::size_t nb_rows, std::size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
IndicesPtr | getIndices ()
| Get a pointer to the vector of indices used. More...
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointT & | operator[] (std::size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Static Public Member Functions

static double | computeConditionNumber (const Eigen::Matrix< double, 6, 6 > &covariance_matrix)
| Compute the condition number of the input point cloud. More...

## Protected Member Functions

bool | initCompute ()
void | applyFilter (Cloud &output) override
| Sample of point indices into a separate PointCloud. More...
void | applyFilter (Indices &indices) override
| Sample of point indices. More...
Protected Member Functions inherited from pcl::FilterIndices< PointT >
void | applyFilter (PointCloud &output) override
| Abstract filter method for point cloud. More...
Protected Member Functions inherited from pcl::Filter< PointT >
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
Protected Member Functions inherited from pcl::PCLBase< PointT >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...

## Static Protected Member Functions

static bool | sort_dot_list_function (std::pair< int, double > a, std::pair< int, double > b)

## Protected Attributes

unsigned int | num_samples_
| Number of indices that will be returned. More...
NormalsConstPtr | input_normals_
| The normals computed at each point in the input cloud. More...
std::vector< Eigen::Vector3f, Eigen::aligned_allocator< Eigen::Vector3f > > | scaled_points_
Protected Attributes inherited from pcl::FilterIndices< PointT >
bool | negative_
| False = normal filter behavior (default), true = inverted behavior. More...
bool | keep_organized_
| False = remove points (default), true = redefine points, keep structure. More...
float | user_filter_value_
| The user given value that the filtered point dimensions should be set to (default = NaN). More...
Protected Attributes inherited from pcl::Filter< PointT >
IndicesPtr | removed_indices_
| Indices of the points that are removed. More...
std::string | filter_name_
| The filter name. More...
bool | extract_removed_indices_
| Set to true if we want to return the indices of the removed points. More...
Protected Attributes inherited from pcl::PCLBase< PointT >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Detailed Description

### template<typename PointT, typename PointNT>
class pcl::CovarianceSampling< PointT, PointNT >

Point Cloud sampling based on the 6D covariances.

It selects the points such that the resulting cloud is as stable as possible for being registered (against a copy of itself) with ICP. The algorithm adds points to the resulting cloud incrementally, while trying to keep all the 6 eigenvalues of the covariance matrix as close to each other as possible. This class also comes with the computeConditionNumber method that returns a number which shows how stable a point cloud will be when used as input for ICP (the closer the value it is to 1.0, the better).

Based on the following publication:

- "Geometrically Stable Sampling for the ICP Algorithm" - N. Gelfand, L. Ikemoto, S. Rusinkiewicz, M. Levoy

Author
  Alexandru E. Ichim, alex..nosp@m.e.ic.nosp@m.him@g.nosp@m.mail.nosp@m..com

Definition at line 62 of file covariance_sampling.h.

## Member Typedef Documentation

## ConstPtr

template<typename PointT , typename PointNT >

using pcl::CovarianceSampling< PointT, PointNT >::ConstPtr = shared_ptr< const CovarianceSampling<PointT, PointNT> >

Definition at line 77 of file covariance_sampling.h.

## Ptr

template<typename PointT , typename PointNT >

using pcl::CovarianceSampling< PointT, PointNT >::Ptr = shared_ptr< CovarianceSampling<PointT, PointNT> >

Definition at line 76 of file covariance_sampling.h.

## Constructor & Destructor Documentation

## CovarianceSampling()

template<typename PointT , typename PointNT >

pcl::CovarianceSampling< PointT, PointNT >::CovarianceSampling | ( |  | ) |

inline

Empty constructor.

Definition at line 80 of file covariance_sampling.h.

References pcl::Filter< PointT >::filter_name_.

## Member Function Documentation

## applyFilter() [1/2]

template<typename PointT , typename PointNT >

void pcl::CovarianceSampling< PointT, PointNT >::applyFilter | ( | Cloud & | output | ) |

override protected virtual

Sample of point indices into a separate PointCloud.

Parameters

  [out] | output | the resultant point cloud

Implements pcl::Filter< PointT >.

Definition at line 212 of file covariance_sampling.hpp.

## applyFilter() [2/2]

template<typename PointT , typename PointNT >

void pcl::CovarianceSampling< PointT, PointNT >::applyFilter | ( | Indices & | indices | ) |

override protected virtual

Sample of point indices.

Parameters

  [out] | indices | the resultant point cloud indices

TODO figure out how to fill the candidate_indices - see subsequent paper paragraphs

Implements pcl::FilterIndices< PointT >.

Definition at line 130 of file covariance_sampling.hpp.

References pcl::computeCovarianceMatrix().

## computeConditionNumber() [1/2]

template<typename PointT , typename PointNT >

double pcl::CovarianceSampling< PointT, PointNT >::computeConditionNumber

Compute the condition number of the input point cloud.

The condition number is the ratio between the largest and smallest eigenvalues of the 6x6 covariance matrix of the cloud. The closer this number is to 1.0, the more stable the cloud is for ICP registration.

Returns
  the condition number

Definition at line 85 of file covariance_sampling.hpp.

References pcl::computeCovarianceMatrix().

## computeConditionNumber() [2/2]

template<typename PointT , typename PointNT >

double pcl::CovarianceSampling< PointT, PointNT >::computeConditionNumber | ( | const Eigen::Matrix< double, 6, 6 > & | covariance_matrix | ) |

static

Compute the condition number of the input point cloud.

The condition number is the ratio between the largest and smallest eigenvalues of the 6x6 covariance matrix of the cloud. The closer this number is to 1.0, the more stable the cloud is for ICP registration.

Parameters

  [in] | covariance_matrix | user given covariance matrix. Assumed to be self adjoint/symmetric.

Returns
  the condition number

Definition at line 97 of file covariance_sampling.hpp.

## computeCovarianceMatrix()

template<typename PointT , typename PointNT >

bool pcl::CovarianceSampling< PointT, PointNT >::computeCovarianceMatrix | ( | Eigen::Matrix< double, 6, 6 > & | covariance_matrix | ) |

Computes the covariance matrix of the input cloud.

Parameters

  [out] | covariance_matrix | the computed covariance matrix.

Returns
  whether the computation succeeded or not

Definition at line 108 of file covariance_sampling.hpp.

## getNormals()

template<typename PointT , typename PointNT >

NormalsConstPtr pcl::CovarianceSampling< PointT, PointNT >::getNormals | ( |  | ) | const

inline

Get the normals computed on the input point cloud.

Definition at line 104 of file covariance_sampling.h.

References pcl::CovarianceSampling< PointT, PointNT >::input_normals_.

## getNumberOfSamples()

template<typename PointT , typename PointNT >

unsigned int pcl::CovarianceSampling< PointT, PointNT >::getNumberOfSamples | ( |  | ) | const

inline

Get the value of the internal num_samples_ parameter.

Definition at line 92 of file covariance_sampling.h.

References pcl::CovarianceSampling< PointT, PointNT >::num_samples_.

## initCompute()

template<typename PointT , typename PointNT >

bool pcl::CovarianceSampling< PointT, PointNT >::initCompute

protected

Definition at line 50 of file covariance_sampling.hpp.

## setNormals()

template<typename PointT , typename PointNT >

void pcl::CovarianceSampling< PointT, PointNT >::setNormals | ( | const NormalsConstPtr & | normals | ) |

inline

Set the normals computed on the input point cloud.

Parameters

  [in] | normals | the normals computed for the input cloud

Definition at line 99 of file covariance_sampling.h.

References pcl::CovarianceSampling< PointT, PointNT >::input_normals_.

## setNumberOfSamples()

template<typename PointT , typename PointNT >

void pcl::CovarianceSampling< PointT, PointNT >::setNumberOfSamples | ( | unsigned int | samples | ) |

inline

Set number of indices to be sampled.

Parameters

  [in] | samples | the number of sample indices

Definition at line 87 of file covariance_sampling.h.

References pcl::CovarianceSampling< PointT, PointNT >::num_samples_.

## sort_dot_list_function()

template<typename PointT , typename PointNT >

static bool pcl::CovarianceSampling< PointT, PointNT >::sort_dot_list_function | ( | std::pair< int, double > | a,
|  | std::pair< int, double > | b
| ) |  |

inline static protected

Definition at line 158 of file covariance_sampling.h.

## Member Data Documentation

## input_normals_

template<typename PointT , typename PointNT >

NormalsConstPtr pcl::CovarianceSampling< PointT, PointNT >::input_normals_

protected

The normals computed at each point in the input cloud.

Definition at line 138 of file covariance_sampling.h.

Referenced by pcl::CovarianceSampling< PointT, PointNT >::getNormals(), and pcl::CovarianceSampling< PointT, PointNT >::setNormals().

## num_samples_

template<typename PointT , typename PointNT >

unsigned int pcl::CovarianceSampling< PointT, PointNT >::num_samples_

protected

Number of indices that will be returned.

Definition at line 135 of file covariance_sampling.h.

Referenced by pcl::CovarianceSampling< PointT, PointNT >::getNumberOfSamples(), and pcl::CovarianceSampling< PointT, PointNT >::setNumberOfSamples().

## scaled_points_

template<typename PointT , typename PointNT >

std::vector<Eigen::Vector3f, Eigen::aligned_allocator<Eigen::Vector3f> > pcl::CovarianceSampling< PointT, PointNT >::scaled_points_

protected

Definition at line 140 of file covariance_sampling.h.

The documentation for this class was generated from the following files:

- pcl/filters/covariance_sampling.h
- pcl/filters/impl/covariance_sampling.hpp